Index: gnu/usr.bin/perl/AUTHORS
===================================================================
RCS file: /tmp/cvs/src/gnu/usr.bin/perl/AUTHORS,v
retrieving revision 1.5
diff -u -p -u -p -r1.5 AUTHORS
--- gnu/usr.bin/perl/AUTHORS	13 Feb 2019 21:15:00 -0000	1.5
+++ gnu/usr.bin/perl/AUTHORS	13 May 2019 15:13:22 -0000
@@ -1213,6 +1213,7 @@ Tim Sweetman			<tim@aldigital.co.uk>
 Tim Witham			<twitham@pcocd2.intel.com>
 Timothe Litt			<litt@acm.org>
 Timur I. Bakeyev		<bsdi@listserv.bat.ru>
+Tina Müller			<cpan2@tinita.de>
 Tkil				<tkil@reptile.scrye.com>
 Tobias Leich			<email@froggs.de>
 Toby Inkster			<mail@tobyinkster.co.uk>
@@ -1298,6 +1299,7 @@ Yuval Kogman			<nothingmuch@woobling.org
 Yves Orton			<demerphq@gmail.com>
 Zachary Miller			<zcmiller@simon.er.usgs.gov>
 Zachary Storer			<zacts.3.14159@gmail.com>
+Zak B. Elep			<zakame@zakame.net>
 Zbynek Vyskovsky		<kvr@centrum.cz>
 Zefram				<zefram@fysh.org>
 Zsbán Ambrus			<ambrus@math.bme.hu>
Index: gnu/usr.bin/perl/INSTALL
===================================================================
RCS file: /tmp/cvs/src/gnu/usr.bin/perl/INSTALL,v
retrieving revision 1.22
diff -u -p -u -p -r1.22 INSTALL
--- gnu/usr.bin/perl/INSTALL	13 Feb 2019 21:15:00 -0000	1.22
+++ gnu/usr.bin/perl/INSTALL	13 May 2019 15:13:22 -0000
@@ -609,7 +609,7 @@ The directories set up by Configure fall
 
 =item Directories for the perl distribution
 
-By default, Configure will use the following directories for 5.28.1.
+By default, Configure will use the following directories for 5.28.2.
 $version is the full perl version number, including subversion, e.g.
 5.12.3, and $archname is a string like sun4-sunos,
 determined by Configure.  The full definitions of all Configure
@@ -2440,7 +2440,7 @@ http://www.chiark.greenend.org.uk/~sgtat
 
 =head1 Coexistence with earlier versions of perl 5
 
-Perl 5.28.1 is not binary compatible with versions of Perl earlier than
+Perl 5.28.2 is not binary compatible with versions of Perl earlier than
 5.28.0.
 In other words, you will have to recompile your XS modules.
 
@@ -2516,9 +2516,9 @@ won't interfere with another version.  (
 libraries after 5.6.0, but not for executables. TODO?)  One convenient
 way to do this is by using a separate prefix for each version, such as
 
-	sh Configure -Dprefix=/opt/perl5.28.1
+	sh Configure -Dprefix=/opt/perl5.28.2
 
-and adding /opt/perl5.28.1/bin to the shell PATH variable.  Such users
+and adding /opt/perl5.28.2/bin to the shell PATH variable.  Such users
 may also wish to add a symbolic link /usr/local/bin/perl so that
 scripts can still start with #!/usr/local/bin/perl.
 
@@ -2533,11 +2533,11 @@ yet.
 
 =head2 Upgrading from 5.27.11 or earlier
 
-B<Perl 5.28.1 may not be binary compatible with Perl 5.27.11 or
+B<Perl 5.28.2 may not be binary compatible with Perl 5.27.11 or
 earlier Perl releases.>  Perl modules having binary parts
 (meaning that a C compiler is used) will have to be recompiled to be
-used with 5.28.1.  If you find you do need to rebuild an extension with
-5.28.1, you may safely do so without disturbing the older
+used with 5.28.2.  If you find you do need to rebuild an extension with
+5.28.2, you may safely do so without disturbing the older
 installations.  (See L<"Coexistence with earlier versions of perl 5">
 above.)
 
@@ -2570,15 +2570,15 @@ Firstly, the bare minimum to run this sc
      print("$f\n");
   }
 
-in Linux with perl-5.28.1 is as follows (under $Config{prefix}):
+in Linux with perl-5.28.2 is as follows (under $Config{prefix}):
 
   ./bin/perl
-  ./lib/perl5/5.28.1/strict.pm
-  ./lib/perl5/5.28.1/warnings.pm
-  ./lib/perl5/5.28.1/i686-linux/File/Glob.pm
-  ./lib/perl5/5.28.1/feature.pm
-  ./lib/perl5/5.28.1/XSLoader.pm
-  ./lib/perl5/5.28.1/i686-linux/auto/File/Glob/Glob.so
+  ./lib/perl5/5.28.2/strict.pm
+  ./lib/perl5/5.28.2/warnings.pm
+  ./lib/perl5/5.28.2/i686-linux/File/Glob.pm
+  ./lib/perl5/5.28.2/feature.pm
+  ./lib/perl5/5.28.2/XSLoader.pm
+  ./lib/perl5/5.28.2/i686-linux/auto/File/Glob/Glob.so
 
 Secondly, for perl-5.10.1, the Debian perl-base package contains 591
 files, (of which 510 are for lib/unicore) totaling about 3.5MB in its
Index: gnu/usr.bin/perl/MANIFEST
===================================================================
RCS file: /tmp/cvs/src/gnu/usr.bin/perl/MANIFEST,v
retrieving revision 1.51
diff -u -p -u -p -r1.51 MANIFEST
--- gnu/usr.bin/perl/MANIFEST	13 Feb 2019 21:18:33 -0000	1.51
+++ gnu/usr.bin/perl/MANIFEST	13 May 2019 15:13:22 -0000
@@ -5572,7 +5572,9 @@ pod/perl5244delta.pod		Perl changes in v
 pod/perl5260delta.pod		Perl changes in version 5.26.0
 pod/perl5261delta.pod		Perl changes in version 5.26.1
 pod/perl5262delta.pod		Perl changes in version 5.26.2
+pod/perl5263delta.pod		Perl changes in version 5.26.3
 pod/perl5280delta.pod		Perl changes in version 5.28.0
+pod/perl5281delta.pod		Perl changes in version 5.28.1
 pod/perl561delta.pod		Perl changes in version 5.6.1
 pod/perl56delta.pod		Perl changes in version 5.6
 pod/perl581delta.pod		Perl changes in version 5.8.1
Index: gnu/usr.bin/perl/Makefile.SH
===================================================================
RCS file: /tmp/cvs/src/gnu/usr.bin/perl/Makefile.SH,v
retrieving revision 1.45
diff -u -p -u -p -r1.45 Makefile.SH
--- gnu/usr.bin/perl/Makefile.SH	13 Feb 2019 21:18:33 -0000	1.45
+++ gnu/usr.bin/perl/Makefile.SH	13 May 2019 15:13:22 -0000
@@ -67,8 +67,16 @@ true)
                             -compatibility_version \
 				${api_revision}.${api_version}.${api_subversion} \
 			     -current_version \
-				${revision}.${patchlevel}.${subversion} \
-			     -install_name \$(shrpdir)/\$@"
+				${revision}.${patchlevel}.${subversion}"
+		case "$osvers" in
+	        1[5-9]*|[2-9]*)
+			shrpldflags="$shrpldflags -install_name `pwd`/\$@ -Xlinker -headerpad_max_install_names"
+			exeldflags="-Xlinker -headerpad_max_install_names"
+			;;
+		*)
+			shrpldflags="$shrpldflags -install_name \$(shrpdir)/\$@"
+			;;
+		esac
 		;;
 	cygwin*)
 		shrpldflags="$shrpldflags -Wl,--out-implib=libperl.dll.a -Wl,--image-base,0x52000000"
@@ -339,6 +347,14 @@ MANIFEST_SRT = MANIFEST.srt
 
 !GROK!THIS!
 
+case "$useshrplib$osname" in
+truedarwin)
+	$spitshell >>$Makefile <<!GROK!THIS!
+PERL_EXE_LDFLAGS=$exeldflags
+!GROK!THIS!
+	;;
+esac
+
 case "$usecrosscompile$perl" in
 define?*)
 	$spitshell >>$Makefile <<!GROK!THIS!
@@ -575,7 +591,7 @@ esac
 
 $spitshell >>$Makefile <<'!NO!SUBS!'
 
-perltoc_pod_prereqs = extra.pods pod/perl5281delta.pod pod/perlapi.pod pod/perlintern.pod pod/perlmodlib.pod
+perltoc_pod_prereqs = extra.pods pod/perl5282delta.pod pod/perlapi.pod pod/perlintern.pod pod/perlmodlib.pod
 generated_pods = pod/perltoc.pod $(perltoc_pod_prereqs)
 generated_headers = uudmap.h bitcount.h mg_data.h
 
@@ -1047,6 +1063,20 @@ $(PERL_EXE): $& $(perlmain_dep) $(LIBPER
 	$(SHRPENV) $(CC) -o perl $(CLDFLAGS) $(CCDLFLAGS) $(perlmain_objs) $(LLIBPERL) $(static_ext) `cat ext.libs` $(libs)
 !NO!SUBS!
         ;;
+
+	darwin)
+	    case "$useshrplib$osvers" in
+	    true1[5-9]*|true[2-9]*) $spitshell >>$Makefile <<'!NO!SUBS!'
+	$(SHRPENV) $(CC) -o perl $(PERL_EXE_LDFLAGS) $(CLDFLAGS) $(CCDLFLAGS) $(perlmain_objs) $(static_ext) $(LLIBPERL) `cat ext.libs` $(libs)
+!NO!SUBS!
+	       ;;
+	    *) $spitshell >>$Makefile <<'!NO!SUBS!'
+	$(SHRPENV) $(CC) -o perl $(CLDFLAGS) $(CCDLFLAGS) $(perlmain_objs) $(static_ext) $(LLIBPERL) `cat ext.libs` $(libs)
+!NO!SUBS!
+	       ;;
+	    esac
+        ;;
+
         *) $spitshell >>$Makefile <<'!NO!SUBS!'
 	$(SHRPENV) $(CC) -o perl $(CLDFLAGS) $(CCDLFLAGS) $(perlmain_objs) $(static_ext) $(LLIBPERL) `cat ext.libs` $(libs)
 !NO!SUBS!
@@ -1119,9 +1149,9 @@ pod/perlintern.pod: $(MINIPERL_EXE) auto
 pod/perlmodlib.pod: $(MINIPERL_EXE) pod/perlmodlib.PL MANIFEST
 	$(MINIPERL) pod/perlmodlib.PL -q
 
-pod/perl5281delta.pod: pod/perldelta.pod
-	$(RMS) pod/perl5281delta.pod
-	$(LNS) perldelta.pod pod/perl5281delta.pod
+pod/perl5282delta.pod: pod/perldelta.pod
+	$(RMS) pod/perl5282delta.pod
+	$(LNS) perldelta.pod pod/perl5282delta.pod
 
 extra.pods: $(MINIPERL_EXE)
 	-@test ! -f extra.pods || rm -f `cat extra.pods`
Index: gnu/usr.bin/perl/README
===================================================================
RCS file: /tmp/cvs/src/gnu/usr.bin/perl/README,v
retrieving revision 1.18
diff -u -p -u -p -r1.18 README
--- gnu/usr.bin/perl/README	13 Feb 2019 21:15:00 -0000	1.18
+++ gnu/usr.bin/perl/README	13 May 2019 15:13:22 -0000
@@ -1,6 +1,6 @@
 Perl is Copyright (C) 1993, 1994, 1995, 1996, 1997, 1998, 1999, 2000,
 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2008, 2009, 2010, 2011, 2012,
-2013, 2014, 2015, 2016, 2017, 2018 by Larry Wall and others.
+2013, 2014, 2015, 2016, 2017, 2018, 2019 by Larry Wall and others.
 All rights reserved.
 
 
Index: gnu/usr.bin/perl/README.haiku
===================================================================
RCS file: /tmp/cvs/src/gnu/usr.bin/perl/README.haiku,v
retrieving revision 1.6
diff -u -p -u -p -r1.6 README.haiku
--- gnu/usr.bin/perl/README.haiku	13 Feb 2019 21:15:00 -0000	1.6
+++ gnu/usr.bin/perl/README.haiku	13 May 2019 15:13:22 -0000
@@ -22,9 +22,9 @@ The build procedure is completely standa
 Make perl executable and create a symlink for libperl:
 
   chmod a+x /boot/common/bin/perl
-  cd /boot/common/lib; ln -s perl5/5.28.1/BePC-haiku/CORE/libperl.so .
+  cd /boot/common/lib; ln -s perl5/5.28.2/BePC-haiku/CORE/libperl.so .
 
-Replace C<5.28.1> with your respective version of Perl.
+Replace C<5.28.2> with your respective version of Perl.
 
 =head1 KNOWN PROBLEMS
 
Index: gnu/usr.bin/perl/README.macosx
===================================================================
RCS file: /tmp/cvs/src/gnu/usr.bin/perl/README.macosx,v
retrieving revision 1.6
diff -u -p -u -p -r1.6 README.macosx
--- gnu/usr.bin/perl/README.macosx	13 Feb 2019 21:15:00 -0000	1.6
+++ gnu/usr.bin/perl/README.macosx	13 May 2019 15:13:22 -0000
@@ -10,9 +10,9 @@ perlmacosx - Perl under Mac OS X
 
 This document briefly describes Perl under Mac OS X.
 
-  curl -O http://www.cpan.org/src/perl-5.28.1.tar.gz
-  tar -xzf perl-5.28.1.tar.gz
-  cd perl-5.28.1
+  curl -O http://www.cpan.org/src/perl-5.28.2.tar.gz
+  tar -xzf perl-5.28.2.tar.gz
+  cd perl-5.28.2
   ./Configure -des -Dprefix=/usr/local/
   make
   make test
@@ -20,7 +20,7 @@ This document briefly describes Perl und
 
 =head1 DESCRIPTION
 
-The latest Perl release (5.28.1 as of this writing) builds without changes
+The latest Perl release (5.28.2 as of this writing) builds without changes
 under all versions of Mac OS X from 10.3 "Panther" onwards. 
 
 In order to build your own version of Perl you will need 'make',
Index: gnu/usr.bin/perl/README.os2
===================================================================
RCS file: /tmp/cvs/src/gnu/usr.bin/perl/README.os2,v
retrieving revision 1.22
diff -u -p -u -p -r1.22 README.os2
--- gnu/usr.bin/perl/README.os2	13 Feb 2019 21:15:00 -0000	1.22
+++ gnu/usr.bin/perl/README.os2	13 May 2019 15:13:22 -0000
@@ -619,7 +619,7 @@ C<set PERLLIB_PREFIX> in F<Config.sys>, 
 
 =item Additional Perl modules
 
-  unzip perl_ste.zip -d f:/perllib/lib/site_perl/5.28.1/
+  unzip perl_ste.zip -d f:/perllib/lib/site_perl/5.28.2/
 
 Same remark as above applies.  Additionally, if this directory is not
 one of directories on @INC (and @INC is influenced by C<PERLLIB_PREFIX>), you
Index: gnu/usr.bin/perl/README.vms
===================================================================
RCS file: /tmp/cvs/src/gnu/usr.bin/perl/README.vms,v
retrieving revision 1.23
diff -u -p -u -p -r1.23 README.vms
--- gnu/usr.bin/perl/README.vms	13 Feb 2019 21:15:00 -0000	1.23
+++ gnu/usr.bin/perl/README.vms	13 May 2019 15:13:22 -0000
@@ -142,11 +142,11 @@ You may need to set up a foreign symbol 
 choice.  Once you have done so, use a command like the following to
 unpack the archive:
 
-    vmstar -xvf perl-5^.28^.1.tar
+    vmstar -xvf perl-5^.28^.2.tar
 
 Then set default to the top-level source directory like so:
 
-    set default [.perl-5^.28^.1]
+    set default [.perl-5^.28^.2]
 
 and proceed with configuration as described in the next section.
 
Index: gnu/usr.bin/perl/av.h
===================================================================
RCS file: /tmp/cvs/src/gnu/usr.bin/perl/av.h,v
retrieving revision 1.15
diff -u -p -u -p -r1.15 av.h
--- gnu/usr.bin/perl/av.h	13 Feb 2019 21:15:00 -0000	1.15
+++ gnu/usr.bin/perl/av.h	13 May 2019 15:13:22 -0000
@@ -47,7 +47,7 @@ Null AV pointer.
 =head1 Array Manipulation Functions
 
 =for apidoc Am|int|AvFILL|AV* av
-Same as C<av_top_index()>.  Deprecated, use C<av_top_index()> instead.
+Same as C<av_top_index()> or C<av_tindex()>.
 
 =for apidoc Am|int|av_tindex|AV* av
 Same as C<av_top_index()>.
Index: gnu/usr.bin/perl/caretx.c
===================================================================
RCS file: /tmp/cvs/src/gnu/usr.bin/perl/caretx.c,v
retrieving revision 1.3
diff -u -p -u -p -r1.3 caretx.c
--- gnu/usr.bin/perl/caretx.c	13 Feb 2019 21:15:00 -0000	1.3
+++ gnu/usr.bin/perl/caretx.c	13 May 2019 15:13:22 -0000
@@ -56,7 +56,19 @@ Perl_set_caret_X(pTHX) {
     SV *const caret_x = GvSV(tmpgv);
 #if defined(OS2)
     sv_setpv(caret_x, os2_execname(aTHX));
-#elif defined(USE_KERN_PROC_PATHNAME)
+    return;
+#elif defined(WIN32)
+    char *ansi;
+    WCHAR widename[MAX_PATH];
+    GetModuleFileNameW(NULL, widename, sizeof(widename)/sizeof(WCHAR));
+    ansi = win32_ansipath(widename);
+    sv_setpv(caret_x, ansi);
+    win32_free(ansi);
+    return;
+#else
+    /* We can try a platform-specific one if possible; if it fails, or we
+     * aren't running on a suitable platform, we'll fall back to argv[0]. */
+# ifdef USE_KERN_PROC_PATHNAME
     size_t size = 0;
     int mib[4];
     mib[0] = CTL_KERN;
@@ -76,7 +88,7 @@ Perl_set_caret_X(pTHX) {
             return;
         }
     }
-#elif defined(USE_NSGETEXECUTABLEPATH)
+# elif defined(USE_NSGETEXECUTABLEPATH)
     char buf[1];
     uint32_t size = sizeof(buf);
 
@@ -95,7 +107,7 @@ Perl_set_caret_X(pTHX) {
             return;
         }
     }
-#elif defined(HAS_PROCSELFEXE)
+# elif defined(HAS_PROCSELFEXE)
     char buf[MAXPATHLEN];
     SSize_t len = readlink(PROCSELFEXE_PATH, buf, sizeof(buf) - 1);
     /* NOTE: if the length returned by readlink() is sizeof(buf) - 1,
@@ -125,15 +137,7 @@ Perl_set_caret_X(pTHX) {
         sv_setpvn(caret_x, buf, len);
         return;
     }
-#elif defined(WIN32)
-    char *ansi;
-    WCHAR widename[MAX_PATH];
-    GetModuleFileNameW(NULL, widename, sizeof(widename)/sizeof(WCHAR));
-    ansi = win32_ansipath(widename);
-    sv_setpv(caret_x, ansi);
-    win32_free(ansi);
-    return;
-#else
+# endif
     /* Fallback to this:  */
     sv_setpv(caret_x, PL_origargv[0]);
 #endif
Index: gnu/usr.bin/perl/doio.c
===================================================================
RCS file: /tmp/cvs/src/gnu/usr.bin/perl/doio.c,v
retrieving revision 1.21
diff -u -p -u -p -r1.21 doio.c
--- gnu/usr.bin/perl/doio.c	13 Feb 2019 21:15:02 -0000	1.21
+++ gnu/usr.bin/perl/doio.c	13 May 2019 15:13:23 -0000
@@ -1173,34 +1173,39 @@ S_argvout_free(pTHX_ SV *io, MAGIC *mg) 
         dir = INT2PTR(DIR *, SvIV(*dir_psv));
 #endif
         if (IoIFP(io)) {
-            SV **pid_psv;
-            PerlIO *iop = IoIFP(io);
+            if (PL_phase == PERL_PHASE_DESTRUCT && PL_statusvalue == 0) {
+                (void)argvout_final(mg, (IO*)io, FALSE);
+            }
+            else {
+                SV **pid_psv;
+                PerlIO *iop = IoIFP(io);
 
-            assert(SvTYPE(mg->mg_obj) == SVt_PVAV);
+                assert(SvTYPE(mg->mg_obj) == SVt_PVAV);
 
-            pid_psv = av_fetch((AV*)mg->mg_obj, ARGVMG_ORIG_PID, FALSE);
+                pid_psv = av_fetch((AV*)mg->mg_obj, ARGVMG_ORIG_PID, FALSE);
 
-            assert(pid_psv && *pid_psv);
+                assert(pid_psv && *pid_psv);
 
-            if (SvIV(*pid_psv) == (IV)PerlProc_getpid()) {
-                /* if we get here the file hasn't been closed explicitly by the
-                   user and hadn't been closed implicitly by nextargv(), so
-                   abandon the edit */
-                SV **temp_psv = av_fetch((AV*)mg->mg_obj, ARGVMG_TEMP_NAME, FALSE);
-                const char *temp_pv = SvPVX(*temp_psv);
+                if (SvIV(*pid_psv) == (IV)PerlProc_getpid()) {
+                    /* if we get here the file hasn't been closed explicitly by the
+                       user and hadn't been closed implicitly by nextargv(), so
+                       abandon the edit */
+                    SV **temp_psv = av_fetch((AV*)mg->mg_obj, ARGVMG_TEMP_NAME, FALSE);
+                    const char *temp_pv = SvPVX(*temp_psv);
 
-                assert(temp_psv && *temp_psv && SvPOK(*temp_psv));
-                (void)PerlIO_close(iop);
-                IoIFP(io) = IoOFP(io) = NULL;
+                    assert(temp_psv && *temp_psv && SvPOK(*temp_psv));
+                    (void)PerlIO_close(iop);
+                    IoIFP(io) = IoOFP(io) = NULL;
 #ifdef ARGV_USE_ATFUNCTIONS
-                if (dir) {
-                    if (unlinkat(my_dirfd(dir), temp_pv, 0) < 0 &&
-                        NotSupported(errno))
-                        (void)UNLINK(temp_pv);
-                }
+                    if (dir) {
+                        if (unlinkat(my_dirfd(dir), temp_pv, 0) < 0 &&
+                            NotSupported(errno))
+                            (void)UNLINK(temp_pv);
+                    }
 #else
-                (void)UNLINK(temp_pv);
+                    (void)UNLINK(temp_pv);
 #endif
+                }
             }
         }
 #ifdef ARGV_USE_ATFUNCTIONS
@@ -1526,31 +1531,14 @@ S_dir_unchanged(pTHX_ const char *orig_p
 #define dir_unchanged(orig_psv, mg) \
     S_dir_unchanged(aTHX_ (orig_psv), (mg))
 
-/* explicit renamed to avoid C++ conflict    -- kja */
-bool
-Perl_do_close(pTHX_ GV *gv, bool not_implicit)
-{
+STATIC bool
+S_argvout_final(pTHX_ MAGIC *mg, IO *io, bool not_implicit) {
     bool retval;
-    IO *io;
-    MAGIC *mg;
 
-    if (!gv)
-	gv = PL_argvgv;
-    if (!gv || !isGV_with_GP(gv)) {
-	if (not_implicit)
-	    SETERRNO(EBADF,SS_IVCHAN);
-	return FALSE;
-    }
-    io = GvIO(gv);
-    if (!io) {		/* never opened */
-	if (not_implicit) {
-	    report_evil_fh(gv);
-	    SETERRNO(EBADF,SS_IVCHAN);
-	}
-	return FALSE;
-    }
-    if ((mg = mg_findext((SV*)io, PERL_MAGIC_uvar, &argvout_vtbl))
-        && mg->mg_obj) {
+    /* ensure args are checked before we start using them */
+    PERL_ARGS_ASSERT_ARGVOUT_FINAL;
+
+    {
         /* handle to an in-place edit work file */
         SV **back_psv = av_fetch((AV*)mg->mg_obj, ARGVMG_BACKUP_NAME, FALSE);
         SV **temp_psv = av_fetch((AV*)mg->mg_obj, ARGVMG_TEMP_NAME, FALSE);
@@ -1717,7 +1705,38 @@ Perl_do_close(pTHX_ GV *gv, bool not_imp
                            SvPVX(*temp_psv), Strerror(errno));
             }
         }
-    freext:
+ freext:
+        ;
+    }
+    return retval;
+}
+
+/* explicit renamed to avoid C++ conflict    -- kja */
+bool
+Perl_do_close(pTHX_ GV *gv, bool not_implicit)
+{
+    bool retval;
+    IO *io;
+    MAGIC *mg;
+
+    if (!gv)
+	gv = PL_argvgv;
+    if (!gv || !isGV_with_GP(gv)) {
+	if (not_implicit)
+	    SETERRNO(EBADF,SS_IVCHAN);
+	return FALSE;
+    }
+    io = GvIO(gv);
+    if (!io) {		/* never opened */
+	if (not_implicit) {
+	    report_evil_fh(gv);
+	    SETERRNO(EBADF,SS_IVCHAN);
+	}
+	return FALSE;
+    }
+    if ((mg = mg_findext((SV*)io, PERL_MAGIC_uvar, &argvout_vtbl))
+        && mg->mg_obj) {
+        retval = argvout_final(mg, io, not_implicit);
         mg_freeext((SV*)io, PERL_MAGIC_uvar, &argvout_vtbl);
     }
     else {
Index: gnu/usr.bin/perl/embed.fnc
===================================================================
RCS file: /tmp/cvs/src/gnu/usr.bin/perl/embed.fnc,v
retrieving revision 1.7
diff -u -p -u -p -r1.7 embed.fnc
--- gnu/usr.bin/perl/embed.fnc	13 Feb 2019 21:17:11 -0000	1.7
+++ gnu/usr.bin/perl/embed.fnc	13 May 2019 15:13:23 -0000
@@ -440,6 +440,7 @@ p	|bool|do_exec3	|NN const char *incmd|i
 #endif
 #if defined(PERL_IN_DOIO_C)
 s	|void	|exec_failed	|NN const char *cmd|int fd|int do_report
+s	|bool	|argvout_final	|NN MAGIC *mg|NN IO *io|bool not_implicit
 #endif
 #if defined(HAS_MSG) || defined(HAS_SEM) || defined(HAS_SHM)
 : Defined in doio.c, used only in pp_sys.c
Index: gnu/usr.bin/perl/embed.h
===================================================================
RCS file: /tmp/cvs/src/gnu/usr.bin/perl/embed.h,v
retrieving revision 1.23
diff -u -p -u -p -r1.23 embed.h
--- gnu/usr.bin/perl/embed.h	13 Feb 2019 21:17:11 -0000	1.23
+++ gnu/usr.bin/perl/embed.h	13 May 2019 15:13:23 -0000
@@ -1746,6 +1746,7 @@
 #define deb_stack_n(a,b,c,d,e)	S_deb_stack_n(aTHX_ a,b,c,d,e)
 #  endif
 #  if defined(PERL_IN_DOIO_C)
+#define argvout_final(a,b,c)	S_argvout_final(aTHX_ a,b,c)
 #define exec_failed(a,b,c)	S_exec_failed(aTHX_ a,b,c)
 #define ingroup(a,b)		S_ingroup(aTHX_ a,b)
 #define openn_cleanup(a,b,c,d,e,f,g,h,i,j,k,l,m)	S_openn_cleanup(aTHX_ a,b,c,d,e,f,g,h,i,j,k,l,m)
Index: gnu/usr.bin/perl/installperl
===================================================================
RCS file: /tmp/cvs/src/gnu/usr.bin/perl/installperl,v
retrieving revision 1.46
diff -u -p -u -p -r1.46 installperl
--- gnu/usr.bin/perl/installperl	13 Feb 2019 21:17:12 -0000	1.46
+++ gnu/usr.bin/perl/installperl	13 May 2019 15:13:23 -0000
@@ -394,6 +394,7 @@ foreach my $file (@corefiles) {
     if (copy_if_diff($file,"$installarchlib/CORE/$file")) {
 	if ($file =~ /\.(\Q$so\E|\Q$dlext\E)$/) {
 	    strip("-S", "$installarchlib/CORE/$file") if $^O eq 'darwin';
+	    fix_dep_names("$installarchlib/CORE/$file");
 	    chmod($SO_MODE, "$installarchlib/CORE/$file");
 	} else {
 	    chmod($NON_SO_MODE, "$installarchlib/CORE/$file");
@@ -824,6 +825,29 @@ sub strip
 	    print "# file '$file' skipped\n" if $opts{verbose};
 	}
     }
+}
+
+sub fix_dep_names {
+    my $file = shift;
+
+    $^O eq "darwin" && $Config{osvers} =~ /^(1[5-9]|[2-9])/
+      && $Config{useshrplib}
+      or return;
+
+    my @opts;
+    my $so = $Config{so};
+    my $libperl = "$Config{archlibexp}/CORE/libperl.$Config{so}";
+    if ($file =~ /\blibperl.\Q$Config{so}\E$/a) {
+        push @opts, -id => $libperl;
+    }
+    else {
+        push @opts, -change => getcwd . "/libperl.$so", $libperl;
+    }
+    push @opts, $file;
+
+    $opts{verbose} and print "  install_name_tool @opts\n";
+    system "install_name_tool", @opts
+      and die "Cannot update $file dependency paths\n";
 }
 
 # ex: set ts=8 sts=4 sw=4 et:
Index: gnu/usr.bin/perl/numeric.c
===================================================================
RCS file: /tmp/cvs/src/gnu/usr.bin/perl/numeric.c,v
retrieving revision 1.3
diff -u -p -u -p -r1.3 numeric.c
--- gnu/usr.bin/perl/numeric.c	13 Feb 2019 21:15:03 -0000	1.3
+++ gnu/usr.bin/perl/numeric.c	13 May 2019 15:13:25 -0000
@@ -565,9 +565,9 @@ Perl_grok_numeric_radix(pTHX_ const char
 Helper for C<grok_number()>, accepts various ways of spelling "infinity"
 or "not a number", and returns one of the following flag combinations:
 
-  IS_NUMBER_INFINITE
+  IS_NUMBER_INFINITY
   IS_NUMBER_NAN
-  IS_NUMBER_INFINITE | IS_NUMBER_NEG
+  IS_NUMBER_INFINITY | IS_NUMBER_NEG
   IS_NUMBER_NAN | IS_NUMBER_NEG
   0
 
Index: gnu/usr.bin/perl/patchlevel.h
===================================================================
RCS file: /tmp/cvs/src/gnu/usr.bin/perl/patchlevel.h,v
retrieving revision 1.46
diff -u -p -u -p -r1.46 patchlevel.h
--- gnu/usr.bin/perl/patchlevel.h	13 Feb 2019 21:15:03 -0000	1.46
+++ gnu/usr.bin/perl/patchlevel.h	13 May 2019 15:13:25 -0000
@@ -15,7 +15,7 @@
 
 #define PERL_REVISION	5		/* age */
 #define PERL_VERSION	28		/* epoch */
-#define PERL_SUBVERSION	1		/* generation */
+#define PERL_SUBVERSION	2		/* generation */
 
 /* The following numbers describe the earliest compatible version of
    Perl ("compatibility" here being defined as sufficient binary/API
Index: gnu/usr.bin/perl/perl.c
===================================================================
RCS file: /tmp/cvs/src/gnu/usr.bin/perl/perl.c,v
retrieving revision 1.36
diff -u -p -u -p -r1.36 perl.c
--- gnu/usr.bin/perl/perl.c	13 Feb 2019 21:17:13 -0000	1.36
+++ gnu/usr.bin/perl/perl.c	13 May 2019 15:13:25 -0000
@@ -3,7 +3,7 @@
  *
  *    Copyright (C) 1993, 1994, 1995, 1996, 1997, 1998, 1999, 2000, 2001
  *    2002, 2003, 2004, 2005, 2006, 2007, 2008, 2009, 2010, 2011, 2012
- *    2013, 2014, 2015, 2016, 2017, 2018 by Larry Wall and others
+ *    2013, 2014, 2015, 2016, 2017, 2018, 2019 by Larry Wall and others
  *
  *    You may distribute under the terms of either the GNU General Public
  *    License or the Artistic License, as specified in the README file.
@@ -3762,7 +3762,7 @@ S_minus_v(pTHX)
 #endif
 
 	PerlIO_printf(PIO_stdout,
-		      "\n\nCopyright 1987-2018, Larry Wall\n");
+		      "\n\nCopyright 1987-2019, Larry Wall\n");
 #ifdef MSDOS
 	PerlIO_printf(PIO_stdout,
 		      "\nMS-DOS port Copyright (c) 1989, 1990, Diomidis Spinellis\n");
Index: gnu/usr.bin/perl/pp.c
===================================================================
RCS file: /tmp/cvs/src/gnu/usr.bin/perl/pp.c,v
retrieving revision 1.30
diff -u -p -u -p -r1.30 pp.c
--- gnu/usr.bin/perl/pp.c	13 Feb 2019 21:17:13 -0000	1.30
+++ gnu/usr.bin/perl/pp.c	13 May 2019 15:13:25 -0000
@@ -1693,7 +1693,8 @@ PP(pp_repeat)
 	    else {
 		dTOPss;
 		ASSUME(MARK + 1 == SP);
-		XPUSHs(sv);
+                MEXTEND(SP, 1);
+                PUSHs(sv);
 		MARK[1] = &PL_sv_undef;
 	    }
 	    SP = MARK + 2;
Index: gnu/usr.bin/perl/pp_hot.c
===================================================================
RCS file: /tmp/cvs/src/gnu/usr.bin/perl/pp_hot.c,v
retrieving revision 1.20
diff -u -p -u -p -r1.20 pp_hot.c
--- gnu/usr.bin/perl/pp_hot.c	13 Feb 2019 21:15:04 -0000	1.20
+++ gnu/usr.bin/perl/pp_hot.c	13 May 2019 15:13:25 -0000
@@ -3932,7 +3932,7 @@ PP(pp_iter)
     case CXt_LOOP_LIST: /* for (1,2,3) */
 
         assert(OPpITER_REVERSED == 2); /* so inc becomes -1 or 1 */
-        inc = 1 - (PL_op->op_private & OPpITER_REVERSED);
+        inc = (IV)1 - (IV)(PL_op->op_private & OPpITER_REVERSED);
         ix = (cx->blk_loop.state_u.stack.ix += inc);
         if (UNLIKELY(inc > 0
                         ? ix > cx->blk_oldsp
@@ -3947,7 +3947,7 @@ PP(pp_iter)
     case CXt_LOOP_ARY: /* for (@ary) */
 
         av = cx->blk_loop.state_u.ary.ary;
-        inc = 1 - (PL_op->op_private & OPpITER_REVERSED);
+        inc = (IV)1 - (IV)(PL_op->op_private & OPpITER_REVERSED);
         ix = (cx->blk_loop.state_u.ary.ix += inc);
         if (UNLIKELY(inc > 0
                         ? ix > AvFILL(av)
Index: gnu/usr.bin/perl/pp_pack.c
===================================================================
RCS file: /tmp/cvs/src/gnu/usr.bin/perl/pp_pack.c,v
retrieving revision 1.4
diff -u -p -u -p -r1.4 pp_pack.c
--- gnu/usr.bin/perl/pp_pack.c	13 Feb 2019 21:15:04 -0000	1.4
+++ gnu/usr.bin/perl/pp_pack.c	13 May 2019 15:13:25 -0000
@@ -1727,7 +1727,10 @@ S_unpack_rec(pTHX_ tempsym_t* symptr, co
 	    if (!checksum) {
                 const STRLEN l = (STRLEN) (strend - s) * 3 / 4;
 		sv = sv_2mortal(newSV(l));
-		if (l) SvPOK_on(sv);
+		if (l) {
+                    SvPOK_on(sv);
+                    *SvEND(sv) = '\0';
+                }
 	    }
 
             /* Note that all legal uuencoded strings are ASCII printables, so
Index: gnu/usr.bin/perl/proto.h
===================================================================
RCS file: /tmp/cvs/src/gnu/usr.bin/perl/proto.h,v
retrieving revision 1.23
diff -u -p -u -p -r1.23 proto.h
--- gnu/usr.bin/perl/proto.h	13 Feb 2019 21:17:13 -0000	1.23
+++ gnu/usr.bin/perl/proto.h	13 May 2019 15:13:25 -0000
@@ -4723,6 +4723,9 @@ STATIC void	S_deb_stack_n(pTHX_ SV** sta
 	assert(stack_base)
 #endif
 #if defined(PERL_IN_DOIO_C)
+STATIC bool	S_argvout_final(pTHX_ MAGIC *mg, IO *io, bool not_implicit);
+#define PERL_ARGS_ASSERT_ARGVOUT_FINAL	\
+	assert(mg); assert(io)
 STATIC void	S_exec_failed(pTHX_ const char *cmd, int fd, int do_report);
 #define PERL_ARGS_ASSERT_EXEC_FAILED	\
 	assert(cmd)
